import React from 'react';
import Scrollbar from 'react-scrollbars-custom';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var bind = createCommonjsModule(function (module) {
/*!
  Copyright (c) 2017 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
/* global define */

(function () {

	var hasOwn = {}.hasOwnProperty;

	function classNames () {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(this && this[arg] || arg);
			} else if (Array.isArray(arg)) {
				classes.push(classNames.apply(this, arg));
			} else if (argType === 'object') {
				for (var key in arg) {
					if (hasOwn.call(arg, key) && arg[key]) {
						classes.push(this && this[key] || key);
					}
				}
			}
		}

		return classes.join(' ');
	}

	if ( module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else {
		window.classNames = classNames;
	}
}());
});

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".styles_container__8ydPS {\n  position: relative;\n  width: 100%;\n  height: 100%;\n  font-family: \"Monaco\", monospace;\n  font-size: 12px;\n  margin: 0;\n  white-space: pre;\n  background-color: #222222;\n  color: #d6d6d6;\n  font-weight: 400;\n  will-change: initial;\n  outline: none;\n}\n.styles_container__8ydPS .styles_line-container__2RyZE {\n  margin: 0;\n  line-height: 20px;\n  padding-left: 6px;\n  display: -webkit-box;\n}\n.styles_container__8ydPS .styles_line-container__2RyZE:first-child {\n  margin-top: 6px;\n}\n.styles_container__8ydPS .styles_line-container__2RyZE:hover {\n  background-color: #444444;\n}\n.styles_container__8ydPS .styles_line-number__2AsVe {\n  line-height: 20px;\n  width: 32px;\n  text-align: right;\n  display: block;\n  user-select: none;\n  box-sizing: border-box;\n  padding-right: 6px;\n  color: #666666;\n}\n.styles_container__8ydPS .styles_line-content__3SI71 {\n  flex: 1;\n  margin: 0;\n  padding: 0;\n}\n";
var styles = { "container": "styles_container__8ydPS", "line-container": "styles_line-container__2RyZE", "line-number": "styles_line-number__2AsVe", "line-content": "styles_line-content__3SI71" };
styleInject(css);

var cx = bind.bind(styles);
var styleTrackX = {
    borderRadius: 0,
    background: 'rgba(255, 255, 255, 0.5)',
    height: 6,
    width: 'calc(100% - 10px)',
    left: 0
};
var styleTrackY = {
    borderRadius: 0,
    background: 'rgba(255, 255, 255, 0.5)',
    width: 6,
    height: 'calc(100% - 10px)',
    top: 0
};
var default_1 = /** @class */ (function (_super) {
    __extends(default_1, _super);
    function default_1() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.scrollbarRef = React.createRef();
        _this.scrollState = null;
        _this.state = {
            lines: []
        };
        _this.componentDidUpdate = function () {
            var autoCatchHeight = _this.props.autoCatchHeight;
            var scrollState = _this.scrollState;
            var scrollBottom = scrollState ? scrollState.contentScrollHeight - (scrollState.scrollTop + scrollState.clientHeight) : 0;
            if (scrollBottom < autoCatchHeight) {
                _this.scrollbarRef.scrollToBottom();
            }
        };
        _this.push = function (data) {
            var lines = __spreadArrays(_this.state.lines);
            if (Array.isArray(data)) {
                lines.splice(-1, 0);
                _this.setState({ lines: lines.concat(data) });
                return;
            }
            lines.push(data);
            _this.setState({ lines: lines });
        };
        _this.handleScroll = function (ScrollState) {
            _this.scrollState = ScrollState;
        };
        return _this;
    }
    default_1.prototype.render = function () {
        var _this = this;
        var lines = this.state.lines;
        return (React.createElement("div", { className: cx('container') },
            React.createElement(Scrollbar, { ref: function (inst) { return _this.scrollbarRef = inst; }, style: { position: 'unset' }, onScroll: this.handleScroll, wrapperProps: {
                    renderer: function (props) {
                        var elementRef = props.elementRef, style = props.style, restProps = __rest(props, ["elementRef", "style"]);
                        return React.createElement("div", __assign({}, restProps, { ref: elementRef, style: __assign(__assign({}, style), { bottom: 6, right: 6 }) }));
                    }
                }, contentProps: {
                    renderer: function (props) {
                        var elementRef = props.elementRef, style = props.style, restProps = __rest(props, ["elementRef", "style"]);
                        return React.createElement("div", __assign({}, restProps, { ref: elementRef, style: __assign({}, style) }));
                    }
                }, trackXProps: {
                    renderer: function (props) {
                        var elementRef = props.elementRef, style = props.style, restProps = __rest(props, ["elementRef", "style"]);
                        return React.createElement("div", __assign({}, restProps, { ref: elementRef, style: __assign(__assign({}, style), styleTrackX) }));
                    }
                }, trackYProps: {
                    renderer: function (props) {
                        var elementRef = props.elementRef, style = props.style, restProps = __rest(props, ["elementRef", "style"]);
                        return React.createElement("div", __assign({}, restProps, { ref: elementRef, style: __assign(__assign({}, style), styleTrackY) }));
                    }
                }, thumbXProps: {
                    renderer: function (props) {
                        var elementRef = props.elementRef, style = props.style, restProps = __rest(props, ["elementRef", "style"]);
                        return React.createElement("div", __assign({}, restProps, { ref: elementRef, style: __assign(__assign({}, style), { borderRadius: 0 }) }));
                    }
                }, thumbYProps: {
                    renderer: function (props) {
                        var elementRef = props.elementRef, style = props.style, restProps = __rest(props, ["elementRef", "style"]);
                        return React.createElement("div", __assign({}, restProps, { ref: elementRef, style: __assign(__assign({}, style), { borderRadius: 0 }) }));
                    }
                } }, lines.map(function (line, index) {
                return (React.createElement("div", { className: cx('line-container'), key: index },
                    React.createElement("span", { className: cx('line-number') }, index),
                    React.createElement("p", { className: cx('line-content') }, line)));
            }))));
    };
    default_1.defaultProps = {
        // 自动滚动 当连续打印时，滚动条距离底部多少距离，混动条将会推理自动滚动
        autoCatchHeight: 50,
    };
    return default_1;
}(React.Component));

export default default_1;
//# sourceMappingURL=index.es.js.map
